/*************************************************************************
*	"crc32.h"
*-------------------------------------------------------------------------
*	$Id: crc32.h 94 2006-09-20 08:51:21Z taro $
*************************************************************************/
#ifndef	CRC32_H_INCLUDED
#define	CRC32_H_INCLUDED

typedef unsigned long	crc32_t;

#ifdef	__cplusplus
  extern "C" {
#endif
typedef struct crc32work_tag
{
	crc32_t		r;
} Crc32work;

extern void		crc32_init(Crc32work * crcwork);
extern void		crc32_calcbyte(Crc32work * crcwork, unsigned c);
extern void		crc32_calc(Crc32work * crcwork, unsigned size, const void * data);
extern crc32_t	crc32_getcrc(Crc32work * crcwork);
extern void		crc32_term(Crc32work * crcwork);

#ifdef	__cplusplus
}
#endif

#define	CRC32_MAX_BUFFER_SIZE	(65536)

#ifdef	__cplusplus
#include	<windows.h>

class	Crc32
{
private:
	crc32_t		r;

public:
	Crc32();
//	~Crc32();

	void		Init(void);
	void		Calc(unsigned c);
	void		Calc(unsigned size, const void * data);
	crc32_t		GetCrc(void);
	int			CalcFile(HANDLE hFile);
};
#endif

#endif
