//////////////////////////////////////////////////////////////////////////
//	"sc_readdvdstructure.cpp"
//------------------------------------------------------------------------
//	$Id: sc_readdvdstructure.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#ifdef	HAVE_CONFIG_H
#	include	"../config.h"
#	undef	HAVE_CONFIG_H
#endif
#include	"devctl.h"

int		DevCtl::ScsiReadDvdStructure(int pathId, int targetId, int lun, unsigned addr, unsigned format, unsigned layer, unsigned size, void * buffer)
{
	Sgt		sgt;

	if ( this->fd < 0 || this->htype != HT_SG )
		return -1;
	for (;;)
	{
		memset(&sgt, 0, sizeof(sgt));
		sgt.fd                  = this->fd;
		sgt.hdr.interface_id    = 'S';
		sgt.hdr.dxfer_direction = SG_DXFER_FROM_DEV;
		sgt.hdr.cmd_len         = SCSI_CDB12_LEN;
	//	sgt.hdr.iovec_count     = 0;
		sgt.hdr.mx_sb_len       = SCSI_SENSE_LEN;
		sgt.hdr.dxfer_len       = size;
		sgt.hdr.dxferp          = (void *)buffer;
		sgt.hdr.cmdp            = sgt.cdb;
		sgt.hdr.sbp             = sgt.sense;
		sgt.hdr.timeout         = this->scsi_timeout;
	//	sgt.hdr.flags           = 0;
	//	sgt.hdr.pack_id         = 0;
	//	sgt.hdr.usr_ptr         = NULL;
		sgt.cdb[0]              = 0xAD; // Read DVD Structure
		sgt.cdb[1]              = lun << 5;
		sgt.cdb[2]             = (BYTE)((addr >> 24) & 0xFF);
		sgt.cdb[3]             = (BYTE)((addr >> 16) & 0xFF);
		sgt.cdb[4]             = (BYTE)((addr >>  8) & 0xFF);
		sgt.cdb[5]             = (BYTE)( addr        & 0xFF);
		sgt.cdb[6]             = (BYTE)layer;
		sgt.cdb[7]             = (BYTE)format;
		sgt.cdb[8]             = (BYTE)((size >> 8) & 0xFF);
		sgt.cdb[9]             = (BYTE)( size       & 0xFF);
	//	sgt.cdb[10]            = 0;
	//	sgt.cdb[11]            = 0;
		if ( ioctl(sgt.fd, SG_IO, &sgt.hdr) < 0 )
			return -1; // error
		if ( (sgt.hdr.info & SG_INFO_OK_MASK) != SG_INFO_OK )
		{
			if ( sgt.hdr.sb_len_wr > 0 && this->ScsiCheckCondition(sgt) > 0 )
				continue;	// retry
			return -1;
		} else
			return sgt.hdr.resid;	// OK
	}
}

