/*************************************************************************
*	"md4rnet.h"
*-------------------------------------------------------------------------
*	$Id: md4rnet.h 94 2006-09-20 08:51:21Z taro $
*************************************************************************/
#ifndef	MD4RNET_H_INCLUDED
#define	MD4RNET_H_INCLUDED

#include	"md4ram.h"

#define	MD4R_NET_ID					{'M','D','4','R','A','M',' ',' '}
#define	MD4R_NET_ID_LENGTH			(8)
#define	MD4R_NET_MARKER_LENGTH		(8)
#define	MD4R_NET_MARKER_SCDB		{'-','S','C','D','B',' ',' ','-'}
#define	MD4R_NET_MARKER_END			{'-','E','N','D',' ',' ',' ','-'}
#define	MD4R_NETAUTH_USER_LENGTH	(16)
#define	MD4R_NETAUTH_PASS_LENGTH	(16)
#define	MD4R_NET_MAX_DATA_LENGTH	(262144)	// 256K
#define	MD4R_NET_SCSI_SENSE_LENGTH	(16)
#define	MD4R_NET_SCSI_CDB_LENGTH	(16)

#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

typedef struct MD4R_NetCmnHead_tag
{
	UCHAR					id[MD4R_PARAM_ID_LENGTH];
	UCHAR					version[MD4R_VERSION_ID_LENGTH];
	UCHAR					marker[MD4R_NET_MARKER_LENGTH];
	UCHAR					length[4];
} MD4R_NetCmnHead;

typedef struct MD4R_NetHead_tag
{
	MD4R_NetCmnHead			chead;
	struct md4r_nethead_att_tag
	{
		unsigned char		headCrc  : 1;
		unsigned char		dataCrc  : 1;
		unsigned char		rsv0_4   : 2;
		unsigned char		recv     : 1;
		unsigned char		send     : 1;
		unsigned char		rsv0_0   : 2;
		UCHAR				rsv1_2[3];
	} att;
	UCHAR					authType;
	UCHAR					authUserLength;
	UCHAR					authPassLength;
	UCHAR					authRsv;
	UCHAR					authUser[MD4R_NETAUTH_USER_LENGTH];
	UCHAR					authPass[MD4R_NETAUTH_PASS_LENGTH];
	UCHAR					subLength[4];
	UCHAR					subOffset[4];
	UCHAR					compMethod;
	UCHAR					compRsv[3];
	UCHAR					compOrigLength[4];
	UCHAR					dataLength[4];
	UCHAR					dataOffset[4];
	UCHAR					headCrc16[2];
	UCHAR					rsv[2];
} MD4R_NetHead;	// 96 bytes

typedef struct MD4R_NetEom_tag
{
	MD4R_NetCmnHead			chead;
	struct md4r_neteom_att_tag
	{
		unsigned char		headCrc  : 1;
		unsigned char		dataCrc  : 1;
		unsigned char		rsv0_4   : 2;
		unsigned char		recv     : 1;
		unsigned char		send     : 1;
		unsigned char		rsv0_0   : 2;
		UCHAR				rsv1_2[3];
	} att;
	UCHAR					dataCrc32[4];
} MD4R_NetEom;	// 36 bytes

enum	MD4R_NetDataIn
{
	MD4R_NET_DATA_UNSPECIFIED = 0x00,
	MD4R_NET_DATA_IN          = 0x01,
	MD4R_NET_DATA_OUT         = 0x02,
};

typedef struct MD4R_NetScdb_tag
{
	UCHAR	length[2];
	UCHAR	scsiStatus;
	UCHAR	pathId;
	UCHAR	targetId;
	UCHAR	lun;
	UCHAR	dataIn;
	UCHAR	rsb7;
	UCHAR	senseInfoLength;
	UCHAR	senseRsv[3];
	UCHAR	senseInfoOffset[4];
	UCHAR	dataTransferLength[4];
	UCHAR	dataBufferOffset[4];
	UCHAR	timeOutValue[4];
	UCHAR	cdbLength;
	UCHAR	cdbRsv[3];
	UCHAR	cdb[MD4R_NET_SCSI_CDB_LENGTH];
} MD4R_NetScdb;	// 48 bytes

#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif

#endif
