//////////////////////////////////////////////////////////////////////////
//	"threadlib.h"
//------------------------------------------------------------------------
//	$Id: threadlib.h 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////
#ifndef	THREADLIB_H_INCLUDED
#define	THREADLIB_H_INCLUDED

#if	defined(WIN32)
# include	<windows.h>
#endif
#if	defined(LINUX)
# include	"linux/defs.h"
# include	<pthread.h>
#endif

//////////////////////////////////////////////////////////////////////////
//	Mutex

class	MutexLib
{
private:
	BOOL			created;
#if	defined(WIN32)
	HANDLE			handle;
#else
	pthread_mutex_t	mutex;
#endif

public:
	MutexLib();
	virtual ~MutexLib();

	int			IsCreate(void) const { return this->created; }
	int			Create(void);
	int			Destroy(void);
	int			Lock(void);
	int			Unlock(void);
};

//////////////////////////////////////////////////////////////////////////
//	Thread

#if	defined(WIN32)
# define	THREAD_CALL	__cdecl
#else
# define	THREAD_CALL
#endif

class	ThreadLib
{
public:
	typedef void (THREAD_CALL * ThreadFunc)(void *);

private:
	BOOL		runFlag;
	void *		arg;
	ThreadFunc	func;
#if	defined(WIN32)
	HANDLE		threadHandle;
	unsigned	threadId;
#else
	pthread_t	thread;
#endif
	MutexLib	runMutex;

public:
	ThreadLib();
	virtual ~ThreadLib();

	int		IsRunning(void) const { return this->runFlag; }
	int		Create(ThreadLib::ThreadFunc func, void * arg);
	int		Destroy(void);
	int		WaitExit(void);

private:
#if	defined(WIN32)
	static unsigned	__stdcall	ThreadLib::start_thread(void * arg);
#else
	static void *				start_thread(void * arg);
#endif

protected:
	void	endthread(void);
};

#endif
