//////////////////////////////////////////////////////////////////////////
//	"dev_setfilepointer.cpp"
//------------------------------------------------------------------------
//	$Id: dev_iocontrol.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"devctl.h"

#if defined(_DEBUG)
# include	<crtdbg.h>
# define	DBGREPORT(param_)	_CrtDbgReport param_
# define	DBGPRINT(param_)	printf param_
#else
# define	DBGREPORT(param_)
# define	DBGPRINT(param_)
#endif

int		DevCtl::DeviceIoControl(DWORD ioctl, void * inbuffer, unsigned insize, void * outbuffer, unsigned outsize, DWORD * byteRet)
{
	BOOL		res;
	DWORD		dw;
	OVERLAPPED	*overlapped;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL, "DevCtl::DeviceIoControl()\n"));
	if ( this->handle == NULL )
		return -1;

	if ( byteRet == NULL )
		byteRet = &dw;
	if ( this->rwmode & RW_ASYNC )
	{
		overlapped = &this->ol;
		::ResetEvent(this->hEvent);
		memset(&this->ol, 0, sizeof(this->ol));
	} else
		overlapped = NULL;

	res = ::DeviceIoControl( this->handle, ioctl,
	  inbuffer , insize,	// input
	  outbuffer, outsize,	// output
	  (DWORD *) byteRet, overlapped);

	if ( this->rwmode & RW_ASYNC )
	{
		DBGREPORT((_CRT_WARN,NULL,NULL,NULL, "Call GetOverlappedResult() : res = %d\n", res));
		if ( res )
		{
			res = ::GetOverlappedResult(this->handle, &this->ol, byteRet, TRUE);
			DBGREPORT((_CRT_WARN,NULL,NULL,NULL, "Pass GetOverlappedResult() : res = %d\n", res));
		}
	}

	return res;
}


int		DevCtl::DeviceIoControl(DWORD ioctl, void * inbuffer, unsigned insize, void * outbuffer, unsigned outsize, DWORD * byteRet, OVERLAPPED & overlapped)
{
	DWORD		dw;

	if ( this->handle == NULL )
		return -1;

	if ( byteRet == NULL )
		byteRet = &dw;

	return ::DeviceIoControl( this->handle, ioctl,
	  inbuffer , insize,	// input
	  outbuffer, outsize,	// output
	  (DWORD *) byteRet, &overlapped);
}
