//////////////////////////////////////////////////////////////////////////
//	"devctl.cpp"
//------------------------------------------------------------------------
//	$Id: devctl.cpp 86 2006-05-28 17:49:27Z taro $
//////////////////////////////////////////////////////////////////////////

#if (_WIN32_WINNT < 0x500)
# undef		_WIN32_WINNT
# define	_WIN32_WINNT	0x500
#endif

#include	"devctl.h"
#include	<tchar.h>
#include	<stdio.h>

#if defined(_DEBUG)
# include	<crtdbg.h>
# define	DBGREPORT(param_)	_CrtDbgReport param_
# define	DBGPRINT(param_)	printf param_
#else
# define	DBGREPORT(param_)
# define	DBGPRINT(param_)
#endif

DevCtl::ScsiCapacityMode	DevCtl::scsiCapacityMode = DevCtl::SCSI_CAPACITYMODE_COUNT;

DevCtl::DevCtl()
{
	this->devname = NULL;
	this->handle = NULL;
	this->htype = HT_UNKNOWN;
#if defined(DEVCTL_USE_FILEIO)
	this->ctl = NULL;
#endif
	this->scsi_timeout = SCSI_TIMEOUT;
	this->hEvent = NULL;
	memset(&this->ol, 0, sizeof(this->ol));
	this->maxCdbSize = SCSI_CDB12_LEN;

#if	defined(DEVCTL_USE_MD4RNET)
	this->socklib = NULL;
#endif

	return;
}

DevCtl::~DevCtl()
{
#if	defined(DEVCTL_USE_MD4RNET)
	if ( this->socklib != NULL )
		this->DestroySock();
#endif

	if ( this->hEvent != NULL )
	{
		::CloseHandle(this->hEvent);
		this->hEvent = NULL;
	}
	if ( this->handle != NULL )
	{
		::CloseHandle(this->handle);
		this->handle = NULL;
	}
	if ( this->devname != NULL )
	{
		delete [] this->devname;
		this->devname = NULL;
	}
#if defined(DEVCTL_USE_FILEIO)
	if ( this->ctl != NULL )
	{
		delete this->ctl;
		this->ctl = NULL;
	}
#endif

	return;
}

