//////////////////////////////////////////////////////////////////////////
//	"net_scsipassthrough.cpp"
//------------------------------------------------------------------------
//	$Id: net_scsipassthroughdirect.cpp 107 2006-09-20 23:51:27Z taro $
//////////////////////////////////////////////////////////////////////////

#if (_WIN32_WINNT < 0x500)
# undef		_WIN32_WINNT
# define	_WIN32_WINNT	0x500
#endif

#include	<winsock2.h>
#include	"../md4r_sock.h"
#include	"../crc16.h"
#include	"../sb8crc.h"

#include	"devctl.h"
#include	<tchar.h>
#include	<stdio.h>
#include	<stddef.h>
# include	<crtdbg.h>

#if defined(_DEBUG)
# define	DBGREPORT(param_)	_CrtDbgReport param_
# define	DBGPRINT(param_)	printf param_
#else
# define	DBGREPORT(param_)
# define	DBGPRINT(param_)
#endif

#if	defined(DEVCTL_USE_MD4RNET) && defined(WIN32)
int			DevCtl::NetScsiCommand(unsigned insize, SCSI_PASS_THROUGH_DIRECT * inspt, unsigned outsize, SCSI_PASS_THROUGH_DIRECT * outspt)
{
	struct Scdb_buffer
	{
		MD4R_NetScdb	scdb;
		BYTE			sense[MD4R_NET_SCSI_SENSE_LENGTH];
	} scdb_buf;
	MD4R_NetScdb	*scdb = &scdb_buf.scdb;
	int				retcode = 0;

	if ( inspt == NULL || inspt->CdbLength > DevCtl::SCSI_CDBMAX_LEN )
		return -1;
	if ( this->NetOpen(this->rwmode) < 0 )
		return -1;

	{
		unsigned		senseLength, senseOffset, outSize = 0, dataOffset = 0;
		BYTE			*outData = NULL;

		memset(&scdb_buf, 0, sizeof(scdb_buf));
		SCSI_PUT16(scdb->length, sizeof(scdb));
		scdb->pathId          = inspt->PathId;
		scdb->targetId        = inspt->TargetId;
		scdb->lun             = inspt->Lun;
		scdb->cdbLength       = inspt->CdbLength;
		memcpy(scdb->cdb, inspt->Cdb, scdb->cdbLength);
		switch ( inspt->DataIn )
		{
		case SCSI_IOCTL_DATA_IN :				// T[of[^
			scdb->dataIn = MD4R_NET_DATA_IN;
			break;
		case SCSI_IOCTL_DATA_OUT:				// T[oɃf[^o
			scdb->dataIn = MD4R_NET_DATA_OUT;
			outSize = inspt->DataTransferLength;
			outData = (BYTE *)inspt->DataBuffer;
			break;
		case SCSI_IOCTL_DATA_UNSPECIFIED:
		default                 :
			scdb->dataIn = MD4R_NET_DATA_UNSPECIFIED;
			break;
		}
		SCSI_PUT32(scdb->dataTransferLength, inspt->DataTransferLength);
		SCSI_PUT32(scdb->timeOutValue      , inspt->TimeOutValue      );
		if ( (senseLength = inspt->SenseInfoLength) < MD4R_NET_SCSI_SENSE_LENGTH )
			senseLength = MD4R_NET_SCSI_SENSE_LENGTH;
		scdb->senseInfoLength = senseLength;
		senseOffset = offsetof(Scdb_buffer, sense);
		SCSI_PUT32(scdb->senseInfoOffset   , senseOffset );

		if ( this->NetScsiSend(scdb, outSize, outData) < 0 )
			retcode = -1;
	}
	if ( retcode == 0 )
	{
		void			*sense_buf, *inp_buf;
		unsigned		sense_size, inp_size;

		if ( (sense_size = outspt->SenseInfoLength) > 0 )
		{
			sense_buf = ((BYTE *)outspt) + outspt->SenseInfoOffset;
		} else
			sense_buf = NULL;

		if ( (inp_size = outspt->DataTransferLength) > 0 )
		{
			inp_buf = outspt->DataBuffer;
		} else
			inp_buf = NULL;

		if ( this->NetScsiRecv(scdb, sense_size, sense_buf, inp_size, inp_buf) < 0 )
		{
			retcode = -1;
		} else
		{
			outspt->ScsiStatus = scdb->scsiStatus;
			switch ( outspt->ScsiStatus )
			{
			case DevCtl::SCSI_STATUS_GOOD:
				break;	// OK
			case DevCtl::SCSI_STATUS_CHECK_CONDITION:
			default:
				break;
			}
			switch ( scdb->dataIn )
			{
			case MD4R_NET_DATA_IN :	// T[óif[^Mj
				outspt->DataTransferLength = SCSI_GET32(scdb->dataTransferLength);
				break;

			case MD4R_NET_DATA_OUT:	// T[oɏo
				outspt->DataTransferLength = SCSI_GET32(scdb->dataTransferLength);
				break;
			}
		}
	}
	this->NetClose();
	return retcode;
}

#endif
