//////////////////////////////////////////////////////////////////////////
//	"sc_inquiry.cpp"
//------------------------------------------------------------------------
//	$Id: sc_inquiry.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	"devctl.h"

int		DevCtl::ScsiInquiry(int pathId, int targetId, int lun, int pageCode, unsigned size, void * buffer)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = SCSI_CDB6_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		spt.spt.Cdb[0]             = DevCtl::SCSI_OP_INQUIRY; // Inqurity
		spt.spt.Cdb[1]             = (lun << 5) + (pageCode < 0 ? 0 : 1);
		spt.spt.Cdb[2]             = pageCode < 0 ? 0 : pageCode;
	//	spt.spt.Cdb[3]             = 0;
		spt.spt.Cdb[4]             = size;
	//	spt.spt.Cdb[5]             = 0;
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				memcpy( buffer, spt.buffer, size);
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

