//////////////////////////////////////////////////////////////////////////
//	"sc_modeselect.cpp"
//------------------------------------------------------------------------
//	$Id: sc_modeselect.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	"devctl.h"

int		DevCtl::ScsiModeSelect(int pathId, int targetId, int lun, BOOL pageFormat, BOOL savePages, unsigned size, const void * buffer)
{
	SPT_DIRECT_BUFFER	spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH_DIRECT));
		spt.spt.Length             = sizeof(SCSI_PASS_THROUGH_DIRECT);
		spt.spt.PathId             = pathId;
		spt.spt.TargetId           = targetId;
		spt.spt.Lun                = lun;
		spt.spt.CdbLength          = size < 256 ? SCSI_CDB6_LEN : SCSI_CDB10_LEN;
		spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
		spt.spt.DataIn             = SCSI_IOCTL_DATA_OUT;
		spt.spt.DataTransferLength = size;
		spt.spt.TimeOutValue       = this->scsi_timeout;
		spt.spt.DataBuffer         = (PVOID)buffer;
		spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
		if ( size < 256 )
		{
			spt.spt.Cdb[0]         = DevCtl::SCSI_OP_MODE_SELECT6; // MODE SELECT(6)
			spt.spt.Cdb[1]         = (lun << 5) + (pageFormat ? 0x10:0) + (savePages ? 0x01 : 0);
		//	spt.spt.Cdb[2]         = 0;
		//	spt.spt.Cdb[3]         = 0;
			spt.spt.Cdb[4]         = (BYTE)size;
		//	spt.spt.Cdb[5]         = 0;
		} else
		{
			spt.spt.Cdb[0]         = DevCtl::SCSI_OP_MODE_SELECT10; // MODE SELECT(10)
			spt.spt.Cdb[1]         = (lun << 5) + (pageFormat ? 0x10:0) + (savePages ? 0x01 : 0);
		//	spt.spt.Cdb[2]         = 0;
		//	spt.spt.Cdb[3]         = 0;
		//	spt.spt.Cdb[4]         = 0;
		//	spt.spt.Cdb[5]         = 0;
		//	spt.spt.Cdb[6]         = 0;
			spt.spt.Cdb[7]         = (BYTE)((size >> 8) & 0xFF);
			spt.spt.Cdb[8]         = (BYTE)( size       & 0xFF);
		//	spt.spt.Cdb[9]         = 0;
		}
		outsize = sizeof(spt);
		if ( (ret = this->ScsiPassThroughDirect(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
				return 0;

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}
