//////////////////////////////////////////////////////////////////////////
//	"sc_ntinq.cpp"
//------------------------------------------------------------------------
//	$Id: sc_ntinq.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<winsock2.h>
#include	<windows.h>
#include	<stddef.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<ctype.h>
#include	"devctl.h"
#if	defined(DEVCTL_USE_MD4RNET)
# include	"../md4r_sock.h"
#endif

int		DevCtl::ScsiGetAddress(SCSI_ADDRESS & scsiAddr)
{
	DWORD	dwSize;

	scsiAddr.Length = sizeof(scsiAddr);
#if	defined(DEVCTL_USE_MD4RNET)
	if ( this->htype == HT_NET && this->devname != NULL && _tcsnicmp(this->devname, TEXT("\\\\.\\MD4RNet"), 11) == 0 )
	{	//	MD4RNet\\<host>:<port>-<pathId>-<targetId>-<lun>
		TCHAR		host[256];
		const TCHAR	*s = &(this->devname[11]);
		int			port, pathId, targetId, lun;

		if ( *s == TEXT('\\') )
			++s;
		if ( MD4R_Sock::GetNetDrivePath(&s, sizeof(host)/sizeof(*host), host, &port, &pathId, &targetId, &lun) < 0 )
			return -1;
		scsiAddr.PortNumber = port;
		scsiAddr.PathId     = pathId;
		scsiAddr.TargetId   = targetId;
		scsiAddr.Lun        = lun;
		return 0;
	}
#endif
	if ( this->DeviceIoControl(IOCTL_SCSI_GET_ADDRESS, NULL, 0,  &scsiAddr, sizeof(scsiAddr), &dwSize) == 0 )
		return -1;
	return 0; //(int)dwSize;
}

// (SCSI_ADAPTER_BUS_INFO) + (NumberOfBuses -1) * sizeof(SCSI_BUS_DATA)) + (InquiryDataSize * NumberOfLUs), 
// InquiryDataSize = (sizeof(SCSI_INQUIRY_DATA) - 1 + INQUIRYDATABUFFERSIZE)

int		DevCtl::ScsiGetInquiryData(unsigned size, void * buffer)
{
	DWORD	dwSize;

	if ( this->DeviceIoControl(IOCTL_SCSI_GET_INQUIRY_DATA,  NULL, 0,  buffer, size, &dwSize) == 0 )
		return -1;
	return (int)dwSize;
}

DevCtl::ScsiDevData *	DevCtl::ScsiGetInquiryData(void)
{
	BYTE				buffer[4096];
	int					size;
	ScsiDevData		   *devData = NULL;
	int				retcode;

	if ( (size = this->ScsiGetInquiryData(sizeof(buffer), buffer)) <= 0 )
		return NULL;
	if ( (devData = new ScsiDevData) == NULL )
		return NULL;

	try
	{
		SCSI_ADAPTER_BUS_INFO	*pa;

		pa = (SCSI_ADAPTER_BUS_INFO *) buffer;
		if ( (devData->numBus = pa->NumberOfBuses) > 0 )
		{
			unsigned				i;
			SCSI_INQUIRY_DATA		*pi;

			if ( (devData->busData = new ScsiBusData [devData->numBus]) == NULL )
				throw -1;
			for ( i = 0; i < devData->numBus; i++ )
			{
				SCSI_BUS_DATA			*pb;
				int						j;

				pb = &pa->BusData[i];
				devData->busData[i].numUnits = 0;
				devData->busData[i].busId = pa->BusData[i].InitiatorBusId;
				pi = (SCSI_INQUIRY_DATA *) (buffer + pa->BusData[i].InquiryDataOffset);
				while ( pa->BusData[i].InquiryDataOffset )
				{
					devData->busData[i].numUnits++;
					if ( pi->NextInquiryDataOffset == 0 )
						break;
					pi = (SCSI_INQUIRY_DATA *) (buffer + pi->NextInquiryDataOffset);
				}
				if ( devData->busData[i].numUnits == 0 )
					continue;
				if ( (devData->busData[i].inqData = new ScsiInqData [devData->busData[i].numUnits]) == NULL )
					throw -1;
				pi = (SCSI_INQUIRY_DATA *) (buffer + pa->BusData[i].InquiryDataOffset);
				j = 0;
				while ( pa->BusData[i].InquiryDataOffset )
				{
					ScsiInqData	   *inqData;

					inqData = &devData->busData[i].inqData[j];
					inqData->pathId     = pi->PathId;
					inqData->targetId   = pi->TargetId;
					inqData->lun        = pi->Lun;
					inqData->devClaimed = pi->DeviceClaimed;
					if ( (inqData->size = pi->InquiryDataLength) > 0 )
					{
						if ( (inqData->data = new BYTE [inqData->size]) == NULL )
							throw -1;
						memcpy(inqData->data, pi->InquiryData, inqData->size);
					}
					j++;
					if ( pi->NextInquiryDataOffset == 0)
						break;
					pi = (SCSI_INQUIRY_DATA *) (buffer + pi->NextInquiryDataOffset);
				}
			}
		}
		retcode = 0;
	}
	catch (int ret) { retcode = ret;}
	if ( retcode < 0 && devData != NULL )
	{
		delete devData;
		devData = NULL;
	}
	return devData;
}


int		DevCtl::ScsiCreateInqData(DevCtl::ScsiInqData & inqData, int pathId, int targetId, int lun)
{
	SCSIINQUIRY	inq;

	if ( this->ScsiInquiry(pathId, targetId, lun, -1, sizeof(inq), &inq) < 0 )
		return -1;
	inqData.pathId     = pathId;
	inqData.targetId   = targetId;
	inqData.lun        = pathId;
	inqData.devClaimed = FALSE;
	inqData.size       = sizeof(inq);
	if ( inqData.data != NULL )
		delete [] inqData.data;
	if ( (inqData.data = new BYTE [sizeof(inq)]) == NULL )
		return -1;
	memcpy(inqData.data, &inq, sizeof(inq));

	return 0;
}
