//////////////////////////////////////////////////////////////////////////
//	"scsi_readcapacity.cpp"
//------------------------------------------------------------------------
//	$Id: sc_readcapacity.cpp 94 2006-09-20 08:51:21Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<ctype.h>
#include	"devctl.h"

int		DevCtl::ScsiReadCapacity(int pathId, int targetId, int lun, unsigned size, void * buffer)
{
	SPT_BUFFER			spt;
	unsigned			outsize;
	int					ret;

	for (;;)
	{
		memset(&spt, 0, sizeof(SCSI_PASS_THROUGH));
		if ( this->maxCdbSize < SCSI_CDB16_LEN || size < sizeof(SCSICAPACITYDATA16) )
		{
			spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
			spt.spt.PathId             = pathId;
			spt.spt.TargetId           = targetId;
			spt.spt.Lun                = lun;
			spt.spt.CdbLength          = SCSI_CDB10_LEN;
			spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
			spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
			spt.spt.DataTransferLength = size;
			spt.spt.TimeOutValue       = this->scsi_timeout;
			spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
			spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
			spt.spt.Cdb[0]             = DevCtl::SCSI_OP_READ_CAPACITY;	// Read Capacity (10)
			spt.spt.Cdb[1]             = lun << 5;
		//	spt.spt.Cdb[2]             = 0;
		//	spt.spt.Cdb[3]             = 0;
		//	spt.spt.Cdb[4]             = 0;
		//	spt.spt.Cdb[5]             = 0;
		//	spt.spt.Cdb[6]             = 0;
		//	spt.spt.Cdb[7]             = 0;
		//	spt.spt.Cdb[8]             = 0;	// 0x01 == Num of Sec (Pertial medium indicator)
		//	spt.spt.Cdb[9]             = 0;
		} else
		{
			spt.spt.Length             = sizeof(SCSI_PASS_THROUGH);
			spt.spt.PathId             = pathId;
			spt.spt.TargetId           = targetId;
			spt.spt.Lun                = lun;
			spt.spt.CdbLength          = SCSI_CDB16_LEN;
			spt.spt.SenseInfoLength    = SCSI_SENSE_LEN;
			spt.spt.DataIn             = SCSI_IOCTL_DATA_IN;
			spt.spt.DataTransferLength = size;
			spt.spt.TimeOutValue       = this->scsi_timeout;
			spt.spt.DataBufferOffset   = offsetof(SPT_BUFFER, buffer);
			spt.spt.SenseInfoOffset    = offsetof(SPT_BUFFER, senseArea);
			spt.spt.Cdb[ 0]            = DevCtl::SCSI_OP_SERVICE_ACTION_IN; 	// READ CAPACITY (16) : SERVICE ACTION IN
			spt.spt.Cdb[ 1]            = (lun << 5) | DevCtl::SCSI_SERVICE_ACTION_READ_CAPACITY16;	// SERVICE ACTION
		//	spt.spt.Cdb[ 2]            = 0;
		//	spt.spt.Cdb[ 3]            = 0;
		//	spt.spt.Cdb[ 4]            = 0;
		//	spt.spt.Cdb[ 5]            = 0;
		//	spt.spt.Cdb[ 6]            = 0;
		//	spt.spt.Cdb[ 7]            = 0;
		//	spt.spt.Cdb[ 8]            = 0;
		//	spt.spt.Cdb[ 9]            = 0;
			spt.spt.Cdb[10]            = (BYTE)((size >> 24) & 0xFF);
			spt.spt.Cdb[11]            = (BYTE)((size >> 16) & 0xFF);
			spt.spt.Cdb[12]            = (BYTE)((size >>  8) & 0xFF);
			spt.spt.Cdb[13]            = (BYTE)( size        & 0xFF);
		//	spt.spt.Cdb[14]            = 0;	// 0x01 == Num of Sec (Pertial medium indicator)
		//	spt.spt.Cdb[15]            = 0;
		}
		outsize = offsetof(SPT_BUFFER, buffer) + spt.spt.DataTransferLength;
		if ( (ret = this->ScsiPassThrough(sizeof(SCSI_PASS_THROUGH), &spt.spt, outsize, &spt.spt)) < 0 )
			return ret;
		switch ( spt.spt.ScsiStatus )
		{
			case SCSI_STATUS_GOOD:
			{
				if ( this->scsiCapacityMode == DevCtl::SCSI_CAPACITYMODE_COUNT )
				{
					INT64	n;

					if ( this->maxCdbSize < SCSI_CDB16_LEN || size < sizeof(SCSICAPACITYDATA16) )
					{
						n = this->ScsiGetLBA((BYTE *)spt.buffer) + 1I64;
						this->ScsiSetLBA((BYTE *)spt.buffer, n);
					} else
					{
						n = SCSI_GET64((BYTE *)spt.buffer) + 1I64;
						SCSI_PUT64((BYTE *)spt.buffer, n);
					}
				}
				memcpy( buffer, spt.buffer, size);
				return 0;
			}

			case SCSI_STATUS_CHECK_CONDITION:
				if ( this->ScsiCheckCondition(spt.senseArea) > 0 )
					break;	// retry
			default:
				return -1;	// error
		}
	}
}

