/*************************************************************************
*	"partition.h"
*-------------------------------------------------------------------------
*	$Id: partition.h 181 2006-09-20 10:50:31Z taro $
*************************************************************************/
#ifndef	PARTITION_H_INCLUDED
#define	PARTITION_H_INCLUDED

#if	defined(LINUX)
#	include	<linux/defs.h>
#endif
#if	defined(WIN32)
#	include	<windows.h>
#endif
#if	!defined(ATTB_PACKED)
# if	defined(LINUX)
#   define	ATTB_PACKED	__attribute ((packed))
# endif
# if	defined(WIN32)
#   define	ATTB_PACKED
# endif
#endif

#if	defined(_MSC_VER)
#	pragma pack(push,1)
#endif

typedef struct
{
	WORD				wSectorSize;
	BYTE				bAllocUnit;
	WORD				wReserveSector;
	BYTE				bFatNumber;
	WORD				wRootEntry;
	WORD				wSectorVolume;
	BYTE				bMediaDescriptor;
	WORD				wFatSector;
	WORD				wSectorPerTrack;
	WORD				wHeadNumber;
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;
	WORD				dummy1;
	BYTE				dummy2;
	DWORD				dwSerialNo;
	BYTE				sVolumeLabel[11];
	BYTE				sFileSystem[8];
} ATTB_PACKED BPBDATA;	/* 51 bytes */

typedef struct			/* FAT32 BPB */
{
	WORD				wSectorSize;
	BYTE				bAllocUnit;
	WORD				wReserveSector;
	BYTE				bFatNumber;
	WORD				wRootEntry;			/* always 0x00 */
	WORD				wSectorVolume;
	BYTE				bMediaDescriptor;
	WORD				wFatSector;			/* always 0x00 */
	WORD				wSectorPerTrack;
	WORD				wHeadNumber;
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;
	DWORD				dwBigFatSector;		/* like wFatSector for FAT32 */
	WORD				wExtFlags;
	WORD				wFsVer;				/* file system version */
	DWORD				dwRootCluster;		/* start cluster for root directory */
	WORD				wFsInfo;			/* filesystem info structure sector */
	WORD				wBackupBootSector;
	BYTE				dumy1[12];
	BYTE				bDrvNo;				/* ==0x80 primary */
	BYTE				dumy2;
	BYTE				bBootSignature;		/* always 0x29 */
	DWORD				dwSerialNo;
	BYTE				sVolumeLabel[11];
	BYTE				sFileSystem[8];
} ATTB_PACKED BF_BPB;

struct NTFSBootBlock
{
	BYTE				jump[3];
	BYTE				oem_id[8];
	WORD				wSectorSize;
	BYTE				bAllocUnit;			/* sectors per cluster */
	WORD				wReserveSector;
	BYTE				bFatNumber;			/* always 0 */
	WORD				wRootEntry;			/* always 0 */
	WORD				wSectorVolume;		/* not use */
	BYTE				bMediaDescriptor;
	WORD				wFatSector;			/* 0 sector per fat */
	WORD				wSectorPerTrack;	/* sector per track */
	WORD				wHeadNumber;		/* heads per cylinder */
	DWORD				dwHiddenSector;
	DWORD				dwLongSectorVolume;	/* not use */
	DWORD				dwBigFatSector;		/* not use */
	DWORD64				totalSectors;
	DWORD64				lcnMFT;				/* Logical Cluster Number for the file $MFT */
	DWORD64				lcnMFTMirror;		/* Logical Cluster Number for the file $MFTMirr */
	DWORD				dwFileRecSeg;		/* Clusters Per File Record Segment */
	DWORD				dwIndexBlock;		/* Clusters Per Index Block */
	DWORD64				volumeSerialNo;
	DWORD				dwChecksum;			/* checksum */
} ATTB_PACKED;

typedef struct
{
	BYTE				bBootFlag;
	BYTE				bUnkown;
	DWORD				dwStartSector;
	DWORD				dwSectorNumber;
	BYTE				reserve[6];
	BYTE				sOsName[16];
	BYTE				sVolumeName[16];
} ATTB_PACKED FMRPARTINF;

typedef struct
{
	BYTE				bBootFlag;
	BYTE				bStart[3];
	BYTE				bPartType;
	BYTE				bEnd[3];
	DWORD				dwRelativeSector;
	DWORD				dwSectorNumber;
} ATTB_PACKED IBMPARTINF;

#if	defined(_MSC_VER)
#	pragma pack(pop)
#endif


#endif
